		__asm
		{
		popad
		mov eax, this
		mov ebx, [pWorkAreaW]
		mov edx, [pWorkArea_uW]
		mov esi, [pWorkArea_vW]
		mov edi, dstp
		mov eax, 8

block_loop_out:
		movq mm0, [ebx]
		movq mm1, [ebx + 8]
		movq mm2, [edx]
		movq mm3, [edx + 8]
		movq mm4, [esi]
		movq mm5, [esi + 8]

		// Clamp to [0, 255]

		pxor mm6, mm6
		pmaxsw mm0, mm6
		pmaxsw mm1, mm6
		pmaxsw mm2, mm6
		pmaxsw mm3, mm6
		pmaxsw mm4, mm6
		pmaxsw mm5, mm6

		movq mm6, y_mask					// Also serves as max values
		pminsw mm0, mm6
		pminsw mm1, mm6
		pminsw mm2, mm6
		pminsw mm3, mm6
		pminsw mm4, mm6
		pminsw mm5, mm6

		// Put bytes in appropriate places

		psllq mm2, 8
		pand mm2, u_mask
		psllq mm3, 8
		pand mm3, u_mask
		psllq mm4, 8
		pand mm4, v_mask
		psllq mm5, 8
		pand mm5, v_mask

		// Merge

		por mm0, mm2
		por mm1, mm3
		por mm0, mm4
		por mm1, mm5

		// Store

		movq [edi + ecx], mm0
		movq [edi + ecx + 8], mm1

		// Advance

		add edi, dst_pitch					// Next image row
		add ebx, 16							// Next work area row
		add edx, 16
		add esi, 16

		dec eax
		jnz block_loop_out

		// Next block

		add ecx, 16
		cmp ecx, row_size
		jl xloop

		// Next row

		mov eax, src_pitch_x8
		add srcp, eax
		mov eax, dst_pitch_x8
		add dstp, eax

		dec ycnt
		jnz yloop

		emms
	}
