	for (y=0; y <= FldHeight-8; y+=8)	
	{
		pSrcW = pSrc;
		pDestW = pDest;
		ctW = ct;
		__asm
		{
		// Loop general reg usage
		//
		// ecx - inner loop counter
		// ebx - src pitch
		// edx - dest pitch
		// edi - dest
		// esi - src pixels

// SPLIT Qword

		align 16
LoopQ:	
		mov		esi, pSrcW   
		lea		eax, [esi+8]
		mov		pSrcW, eax					// save for next time
		mov		ebx, src_pit 
		mov		eax, pWorkAreaW

		// expand bytes to words in work area
		pxor	mm7, mm7
		
		movq	mm0, qword ptr[esi]			// # 0
		movq	mm2, qword ptr[esi+ebx]		// # 1

		movq	mm1, mm0
		punpcklbw mm0, mm7					// low bytes to words
		movq	qword ptr[eax], mm0			// low words to work area
		punpckhbw mm1, mm7					// high bytes to words
		movq	qword ptr[eax+8], mm1		// high words to work area
		
		movq	mm3, mm2
		punpcklbw mm2, mm7					// low bytes to words
		movq	qword ptr[eax+1*16], mm2	// low words to work area
		punpckhbw mm3, mm7					// high bytes to words
		movq	qword ptr[eax+1*16+8], mm3	// high words to work area
		
		lea		esi, [esi+2*ebx]

		movq	mm0, qword ptr[esi]			// #2
		movq	mm2, qword ptr[esi+ebx]		// #3

		movq	mm1, mm0
		punpcklbw mm0, mm7					// low bytes to words
		movq	qword ptr[eax+2*16], mm0	// low words to work area
		punpckhbw mm1, mm7					// high bytes to words
		movq	qword ptr[eax+2*16+8], mm1	// high words to work area
		
		movq	mm3, mm2
		punpcklbw mm2, mm7					// low bytes to words
		movq	qword ptr[eax+3*16], mm2	// low words to work area
		punpckhbw mm3, mm7					// high bytes to words
		movq	qword ptr[eax+3*16+8], mm3	// high words to work area
		
		lea		esi, [esi+2*ebx]

		movq	mm0, qword ptr[esi]			// #4
		movq	mm2, qword ptr[esi+ebx]		// #5

		movq	mm1, mm0
		punpcklbw mm0, mm7					// low bytes to words
		movq	qword ptr[eax+4*16], mm0	// low words to work area
		punpckhbw mm1, mm7					// high bytes to words
		movq	qword ptr[eax+4*16+8], mm1	// high words to work area
		
		movq	mm3, mm2
		punpcklbw mm2, mm7					// low bytes to words
		movq	qword ptr[eax+5*16], mm2	// low words to work area
		punpckhbw mm3, mm7					// high bytes to words
		movq	qword ptr[eax+5*16+8], mm3	// high words to work area
		
		lea		esi, [esi+2*ebx]

		movq	mm0, qword ptr[esi]			// #6
		movq	mm2, qword ptr[esi+ebx]		// #7

		movq	mm1, mm0
		punpcklbw mm0, mm7					// low bytes to words
		movq	qword ptr[eax+6*16], mm0	// low words to work area
		punpckhbw mm1, mm7					// high bytes to words
		movq	qword ptr[eax+6*16+8], mm1	// high words to work area
		
		movq	mm3, mm2
		punpcklbw mm2, mm7					// low bytes to words
		movq	qword ptr[eax+7*16], mm2	// low words to work area
		punpckhbw mm3, mm7					// high bytes to words
		movq	qword ptr[eax+7*16+8], mm3	// high words to work area	
		}
